# -*- coding: utf-8 -*-
"""
Created on Mon Oct 26 12:21:09 2015

@author: nikol_000
"""

import matplotlib.pyplot as plt
import numpy as np
import math as mth

#Function to simplyfy plotting after each simulation
def ploteverything():
    plotall_opt_trajec(opt_trajec_data)
    plotall_plant_trajec(plant_trajec_data)
    plot_icebergs(icebergs_init)
    grid(b=True)

def plot_input(inputs, color='b'):
    plt.figure(1)
    plt.grid()
    plt.plot(inputs, 'b')


def plot_plant_trajec(plant_trajec):
    x = []
    y = []
    psi = []
    for i in range(len(plant_trajec)):
        x.append(   plant_trajec[i][0] )
        y.append(   plant_trajec[i][1] )
        psi.append( plant_trajec[i][2] )
    plt.plot(x,y, color='green', linewidth=3 )
    plt.show()

def plot_icebergs(icebergs):    
    iceplot_x = [iceberg[0] for iceberg in icebergs]
    iceplot_y = [iceberg[1] for iceberg in icebergs] 
    plt.plot(iceplot_x, iceplot_y, 'ro', label='Icebergs')
    

def plotUAV(z,scale,dec, color='b'):
#    plt.clf()
       
    x = z[0]
    y = z[1]
    psi = z[2]

    plt.figure(0)
    plt.axis('equal')
    plt.plot(x,y, color, label='Optimal waypoint following')
#    
    L = 2.27*scale;
    W = L*(3.3/2.27);

    xCoor = [(L/2), .9*(L/2), .5*(L/2), -.1*(L/2), -.5*(L/2), 0, -.6*(L/2),
             -.85*(L/2), -1.1*(L/2), -.85*(L/2), -(L/2), -(L/2), -.85*(L/2),
            -1.1*(L/2), -.85*(L/2), -.6*(L/2), 0, -.5*(L/2), -.1*(L/2),
            .5*(L/2), .9*(L/2), (L/2)]
    yCoor = [0, -(1./11)*(W/2), -(1./11)*(W/2), -(W/2), -(W/2), -(1./11)*(W/2),
            -(1./11)*(W/2), -(3./11)*(W/2), -(3./11)*(W/2), -(1./11)*(W/2),
            -(1./11)*(W/2), (1./11)*(W/2), (1./11)*(W/2), (3./11)*(W/2),
            (3./11)*(W/2), (1./11)*(W/2), (1./11)*(W/2), (W/2), (W/2),
            (1./11)*(W/2), (1./11)*(W/2), 0]
    N = len(x)
    now = 0
    for i in range(N):
        if i == now:
            tmpR = [ [np.cos(psi[i][0]),-np.sin(psi[i][0])],[np.sin(psi[i][0]),np.cos(psi[i][0])] ]
            UAV = np.dot(tmpR,[xCoor,yCoor])
            plt.fill(x[i]+UAV[0],y[i]+UAV[1], color='yellow',edgecolor='black')
            now += mth.floor(N/dec)
            
def plotall_plant_trajec(plant_trajec_data):
    for data in plant_trajec_data:
        plot_plant_trajec(data)

def plotall_opt_trajec(opt_trajec_data):
    for data in opt_trajec_data:
        plotUAV(data, 5, 10)
    
    
    
if __name__ == '__main__':
    ploteverything()
    
    
    
    
    
    
    
    
    
    
    
